// C Source File
// Created 24/08/2002; 21:51:50

#define USE_TI89              // Produce .89z File
#define USE_TI92PLUS          // Produce .9xz File

#define OPTIMIZE_ROM_CALLS    // Use ROM Call Optimization

#define SAVE_SCREEN           // Save/Restore LCD Contents

#include <tigcclib.h>         // Include All Header Files
#include "special.h"


// variables globales
 // suupprime des variables globales car pas bien on s'en sert seulemnt ds prog prcipal. compteur pour les boucles, je dis que c'est une variable global cmme a pas besoin de l'initialiser dans chaque procdure
// je les mets en commentaire comme a on peut les rutiliser plus tard si le beoin se fait sentir int sorti1=0,sorti2=0;
GRDEUR ecran;
short rg_esc, col_esc, col_haut, col_droite, col_gauche, col_2nd;	
CARACT ennemi[29];
EXPLO explo[max_explo];
char ralenti = middle; 
/*
Attention!!!
En fait, c'est une variable initialise lors de sa dclaration ce qui ne signifie pas qu'elle est 
initialise  chaque appel du programme mais seulement lors du 1 appel!
*/







// Main Function
void _main(void) 
{
	int calc = CALCULATOR;
	
	ecran.largeur = LCD_WIDTH - 10;
	ecran.hteur = LCD_HEIGHT - 17;
	
	if (calc == 0) {
		rg_esc = ti89rg_esc;
		col_esc = ti89col_esc;
		col_haut = ti89col_haut;
		col_droite = ti89col_droite;
		col_gauche = ti89col_gauche;	
		col_2nd = ti89col_2nd;	
	} else {
		rg_esc = ti92rg_esc;
		col_esc = ti92col_esc;
		col_haut = ti92col_haut;
		col_droite = ti92col_droite;
		col_gauche = ti92col_gauche;
		col_2nd = ti92col_2nd;		
	}
	



		
	POS vsso = {trunc(ecran.largeur/2), trunc(ecran.hteur/2)}; // position du vaisseau
	float dir = PI/2;
	
//	short tir = 0; // boolen
	POS balle; // on supprime le tableau car il faut pas calculer  l'avance sinon ralentissement et cet variable corespond  la position initiale
	unsigned short numballe = 0;
//	int dirb = dir; // on suprime cete variable + ballei car on prendra comme rfrence le vsso ce qui permettra de faire l'illusion d'un tir rapide
	
	unsigned char a,z; // compteurs dans mes boucles	

	unsigned short tps = 0; // cette variable nous permet de compter le nombre de tours de la boucle principale: while
	char mort = 0, nes = 0; //compte le nombre d'ennemis tus et ns ms seulement petit
	char type_ennemi[4] = {t1, t1, t1, t1}; 
	char stop1 = 0, stop2 = 0; //variable boolenne
	unsigned short nbdepla = 0, chgtdir = 0, oeufpondu = 0; // la soucoupe pond des oeufs et change de direction au hasard

	short vie = 6, niveau = 1;
	unsigned long int points = 0;
	

	if (presentation ()) return;

  INT_HANDLER interrupt1 = GetIntVec(AUTO_INT_1);	// save auto-interrupt 1
	// destroy auto-interrupt 1 so that it doesn't interfere with _rowread()
	SetIntVec(AUTO_INT_1,DUMMY_HANDLER);

	// dessine le terrain de jeu initial
	randomize();
	chargeniv(type_ennemi[0], type_ennemi[1], type_ennemi[2], type_ennemi[3], &vsso, &dir,
						niveau, points, vie);

	while (!stop2) {
	
		while (!arret() && !stop1) {
	
			if (_rowread(rg_fleche) & col_haut) 
					deplavsso(&vsso, dir);
			
			if (col_gauche & _rowread(rg_fleche)) 
					deplacanon (vsso, &dir, vit_canon);
			
			if (col_droite & _rowread(rg_fleche))
					deplacanon (vsso, &dir, -vit_canon);
	
			// on peut se tlporter a un endroit au hasard
			if (col_2nd & _rowread(rg_2nd)) 
					teleport (&vsso, &dir);
			
			
		/* le tir ralentit beaucoup trop le jeu pour avoir une vitesse constante des ennemis ont bloque le tir
			if ((col_2nd & _rowread(rg_2nd)) && (!tir))
					tir = 1; */
			
			// On vrifie que le tir est enclench
			//if (tir) {
				// efface l'ancienne balle pour rafficher la nvelle blle et on a le mvt
				
			// j'ai align le groupe pour qu'il soit bon
			// methode: slectionner + Ctrl D
			if (numballe != 0) 
				//DrawPix (balle.x, balle.y, A_XOR);	
				dessine_balle (balle);
			if (numballe == nb_balle) {
				// fin de l'affichage de la trajectoire
				//tir = 0; // false
				numballe = 0;
			} else {
				balle.x = trunc (vsso.x + cos (dir) * (taille_vsso/2 + 2 + numballe * espace_balle));
				balle.y = trunc (vsso.y - sin (dir) * (taille_vsso/2 + 2 + numballe * espace_balle));
				transfert (&balle, taille_balle);	
				//DrawPix (balle.x, balle.y, A_XOR);
				dessine_balle (balle);
				for (a = 0; a < 29; a++) {
					if (ennemi[a].etat == 1) {
						if (collision (ennemi[a].posi, balle, (region_balle + 8 + 4 * ennemi[a].type.taille)/2)) {
							//tir = 0; // false
							numballe = 0; // on arrte la balle
							// on efface l'ennemi
							dessinennemi (ennemi[a].posi, ennemi[a].type); 
							//on comptabilise les points de la mort de l'ennemi
							affichage_pt (points);
							points += ennemi[a].type.forme * pt_forme
												+ (2 - ennemi[a].type.taille) * pt_taille + pt_defaut;
												// (2 - taille) c pr que les petits qui vont + vite raporte +
							affichage_pt (points);
							
							// mort de l'ennemi [a] mais on continue car plusieurs ennemis: les bbs et le missile (t3 & t4)
							/*
							au dbut, je me suis tromp les bbs puis le missiles
							:-)
							*/
							// dessine  l'explosion de l'ennemi
							char bon = 0;
							for (z = 0; z < max_explo ; z++) {
								if (explo[z].etat == 0) {
									explo[z].posi = ennemi[a].posi;
									explo[z].etat = tps_explo;
									bon = 1;
									dessineexplo (explo[z].posi);
									break;
								}
							}
							if (!bon) {
								unsigned char h = random(max_explo); // on prend un nombre au hasard pour viter une boucle pour calculer le plus petit temps d'explosion
								dessineexplo (explo[h].posi); 
								explo[h].posi = ennemi[a].posi;
								explo[h].etat = tps_explo;					
								dessineexplo (explo[h].posi);			
							}
						
							// si l'ennemi est la soucoupe on la compte pas dans les morts sinon invincible
							if (a == 28) mort--;
							mort++;
							// maintenant il faut tenir compte des oeufs de la soucoupe
							if (ennemi[a].type.taille == gros) {
								if (ennemi[a+1].etat == 0) naissance( &ennemi[a+1] );
								if (ennemi[a+2].etat == 0) naissance( &ennemi[a+2] );
							}
							if (ennemi[a].type.taille == moyen) {
								/*
								0: gros
								1, 2: moyen
								3, 4, 5, 6: petit
								
								7: gros
								8, 9: moyen
								10, 11, 12, 13: petit
								
								14: gros
								15, 16: moyen
								17, 18, 19, 20: petit
								
								21: gros
								22, 23: moyen
								24, 25, 26, 27: petit
								
								a prend les valeurs: 0  6, 7  13, 14  20 et 21  28
								le modulo '%' permet d'avoir le reste, on obtient avec (a % 7) si c'est le premier 
								ou deuxime	moyen dans le tableau et on sait ainsi quelles sont les petits qui vont natre
								magique: non, logique: oui! :-)
								Je t'avoue j'ai eu quelques problmes pour trouver la bonne combinaison
								*/
								if (ennemi[ a + (a % 7) + 1 ].etat == 0) naissance ( &ennemi[ a + (a % 7) + 1 ] );
								if (ennemi[ a + (a % 7) + 2 ].etat == 0) naissance ( &ennemi[ a + (a % 7) + 2 ] );

								nes += 2;

							}
							//une seule balle peut tuer plusieurs ennemis qui sont proches
							if ((ennemi[a].type.forme == t3) || (ennemi[a].type.forme == t4)) {
								// une sorte de transformation avant de mourir
								mort--;
								//ennemi[a] tjrs vivant ms forme m: missile
								ennemi[a].type.forme = m;
								ennemi[a].type.taille = petit; // pour que le issile va aussi vite que les petits
									
								// pas besoin de se casser les couilles  chercher on copie la partie de deplaennemi
								if (vsso.x - ennemi[a].posi.x != 0) {
									if (vsso.x < ennemi[a].posi.x) {
										ennemi[a].dir = atan ( -(vsso.y - ennemi[a].posi.y) / (vsso.x - ennemi[a].posi.x) );  
										ennemi[a].dir += PI;
									} else {
										ennemi[a].dir = atan ( (vsso.y - ennemi[a].posi.y) / (-vsso.x + ennemi[a].posi.x) );
									}
								}	// normalement si horizontale du missile il y a un bug ms c'est fait exprs et on aura une ttrajectoire alatoire
								// naissance  l'cran de l'ennemi
								dessinennemi (ennemi[a].posi, ennemi[a].type);											
							} else {
								ennemi[a].etat = 2;
							}
							//if (ennemi[a].type.forme == m) ennemi[a].etat = 1; // invincibilit des ennemis
							//if (a == 28) ennemi[a].etat = 1; // invincibilit de la soucoupe
						}
					}
						
				}
				numballe++;
			}
	
			//}
			
			// cette partie qui suit ne concerne que les ennemis qu'on va ralentir sinon le joueur n'a pas trop
			// le temps de ragir
			
			if ((mort == 28) && (ennemi[28].etat != 1)) stop1 = 1;
			tps++;
			
			// on on fait des modifs car il y a la soucoupe et ses oeufs qui foutent la merde 
			
			if ((tps >= tps_prem_eclosion) && (ennemi[0].etat == 0)) {
					ennemi[0].etat = 1;
					DrawPix (ennemi[0].posi.x, ennemi[0].posi.y, A_XOR);
					transfert (&ennemi[0].posi, 16);
					dessinennemi (ennemi[0].posi, ennemi[0].type);
						
					//tps = tps_eclosion;
					
			} 
			
		
			
			//if (ennemi[0].etat == 0) continue; // au dbut pas de sprite  afficher et a va trs vite
			if ((tps >= tps_prem_eclosion +  tps_eclosion) && (ennemi[7].etat == 0)) {
					ennemi[7].etat = 1;
					DrawPix (ennemi[7].posi.x, ennemi[7].posi.y, A_XOR);// on oublie pas d'effacer l'oeuf clos
					transfert (&ennemi[7].posi, 16);
					dessinennemi (ennemi[7].posi, ennemi[7].type);
					
			}
			if ((tps >= tps_prem_eclosion + 2 * tps_eclosion) && (ennemi[14].etat == 0)) {
					ennemi[14].etat = 1;
					DrawPix (ennemi[14].posi.x, ennemi[14].posi.y, A_XOR);
					transfert (&ennemi[14].posi, 16);
					dessinennemi (ennemi[14].posi, ennemi[14].type);
				
			}
			if ((tps >= tps_prem_eclosion + 3 * tps_eclosion) && (ennemi[21].etat == 0)) {
					ennemi[21].etat = 1;
					DrawPix (ennemi[21].posi.x, ennemi[21].posi.y, A_XOR);
					transfert (&ennemi[21].posi, 16);
					dessinennemi (ennemi[21].posi, ennemi[21].type);
					
			}	
	
			//naissance_depart(tps);
			if (tps % ralenti != 0) continue; // en fait on arrte pas la boucle mais seulement le tour en cours, on regarde la partie qui suit seulement si on a un multiple de "ralenti"
			if (tps > tps_prem_eclosion + 3 * tps_eclosion) tps = 0; // le dernier  apparatre doit tre apparu sinon problme
	

			
			for (a = 0; a < max_explo; a++) {
				if (explo[a].etat == 1) 
					// explosion termin
					dessineexplo (explo[a].posi);
				if (explo[a].etat != 0) explo[a].etat--;
			}
	
			
			for (a = 0; a < 29; a++) {
				if (ennemi[a].etat == 1) {
					/* naissance 
					transfert (&ennemi[a].posi, 8 + 4 * ennemi[a].type.taille);
					dessinennemi (ennemi[a].posi, ennemi[a].type); */
				  ennemi[a].etat = deplaennemi (&ennemi[a].posi, &ennemi[a].dir, ennemi[a].type, vsso);
				  if (ennemi[a].etat == 2) mort++; // il ne faut pas oublier de compter le missile comme mort
				  if (collision (ennemi[a].posi, vsso, (region_vsso + 8 + 4 * ennemi[a].type.taille)/2)) {
					 // si tu mets en commentaire ces leignes le joueur est invincible
					 dessine_balle (balle); // efface la dernire balle
					  
					 // gestion de la mort de l'ennemi
						gestion_tueur(a, vsso);
								  
					  // gestion de la mort du joueur
					  perdu (vie, vsso, dir, points);
					  if (vie == 0) {
				  		// restore auto interrupt 1; ne surtout pas oubli; sinon plante la calculette
					  	SetIntVec(AUTO_INT_1,interrupt1);
					  	if (menu()) {
					  		return;	
					  	} else {
							  interrupt1 = GetIntVec(AUTO_INT_1);	
								SetIntVec(AUTO_INT_1,DUMMY_HANDLER);
								randomize();
								points = 0;
								vie = 6;
								niveau = 1;
								for (z = 0; z < 4; z++)
									type_ennemi[z] = t1;
								chargeniv(type_ennemi[0], type_ennemi[1], type_ennemi[2], type_ennemi[3], &vsso, &dir,
													niveau, points, vie);	
								tps = mort = nes = numballe = 0;																					  		
					  	}
					  	continue;
					  }
					  vie--;
					  chargeniv(type_ennemi[0], type_ennemi[1], type_ennemi[2], type_ennemi[3], &vsso, &dir,
											niveau, points, vie);
						// on n'oublie pas de rinitialiser les variables
						tps = 0;
						mort = 0;
						nes = 0; 
						numballe = 0;
					  continue; // */
				  }
				} 
			}
			
			// on s'occupe de la soucoupe
			
			if ((nes == 16) && (ennemi[28].etat == 0)) {
				ennemi[28].etat = 1;
				nbdepla = 0;
				chgtdir = 5;
				oeufpondu = 0;
				dessinennemi (ennemi[28].posi, ennemi[28].type);
				continue;
			}
			
			if (ennemi[28].etat == 1) {
				nbdepla++;
				if (nbdepla > chgtdir) {
					nbdepla = 0;
					ennemi[28].dir = hasard()*2*PI;
					if (oeufpondu < 4) {
						init_oeuf_s ( &ennemi[oeufpondu*7], type_ennemi[0] );
						oeufpondu++;
						mort--; // il faut tuer plus de 28 ennemis car on en recre
						if (oeufpondu == 1) tps = 0;
					} else {
						chgtdir += 2;
					}
					if (oeufpondu == 0) {
						ennemi[a].type.taille = gros;					
						//tps = 0;
					}
				}
			}
				
		} // fin de la boucle du jeu
		stop2 = 1;	
		if (mort == 28) {
			mort = 0;
			stop2 = stop1 = 0;
			
		// cherche la nouvelle combinaison des types d'ennemis
			if (type_ennemi[0] == t4) {
				type_ennemi[0] = t1;
				if (type_ennemi[1] == t4) {
					type_ennemi[1] = t1;
					if (type_ennemi[2] == t4) {
						type_ennemi[2] = t1;
						if (type_ennemi[3] == t4) {					
							//fin du jeu: le joueur a gagn
							printf("gagn");
						/*	ngetchx();
							ngetchx();*/
							stop2 = 1;
						} else {
							type_ennemi[3]++;
						}
					} else {
						type_ennemi[2]++;
					}
				} else {
					type_ennemi[1]++;
				}
			} else {
				type_ennemi[0]++;
			}
			niveau++;
			if ((niveau - 1) % 4 == 0) vie++; // tous les 4 niveaux dpasses le joueur a 1 vie supplmentaire
			
			dessine_balle (balle); // efface la dernire balle
			
			victoire (vsso, dir, niveau, points, vie);
		/*	ngetchx();
			ngetchx();
			*/			
			// recharge le tableau ennemi*/
			chargeniv(type_ennemi[0], type_ennemi[1], type_ennemi[2], type_ennemi[3], &vsso, &dir,
								niveau, points, vie);
			// on n'oublie pas de rinitialiser les variables
			tps = 0;
			mort = 0;
			nes = 0; 
			numballe = 0;	
		}
	}
  // restore auto interrupt 1; ne surtout pas oubli; sinon plante la calculette
  SetIntVec(AUTO_INT_1,interrupt1);
}

